// FontMake.cpp : Defines the entry point for the console application.
//

#include <stdio.h>
#include <ostream.h>
#include <windows.h>

int main(int argc, char* argv[])
{
	if(argc<3)
	{
		cout<<"FontMake <ifile.bmp> <ofile.fnt>"<<endl;
		return(0);
	}

	HDC hdc=CreateCompatibleDC(NULL);

	HBITMAP hbmNew=(HBITMAP)LoadImage(NULL,argv[1],IMAGE_BITMAP,0,0,LR_LOADFROMFILE);

	HBITMAP hbmOld=(HBITMAP)SelectObject(hdc,hbmNew);

	BITMAP bmp;

	GetObject(hbmNew,sizeof(BITMAP),&bmp);

	int CharWidth=bmp.bmWidth/16;
	int CharHeight=bmp.bmHeight/6;
	
	int CellWidth=((CharWidth+7)/8)*8;

	HDC hdcChar=CreateCompatibleDC(NULL);

	HBITMAP hbmChar=CreateCompatibleBitmap(hdc,CellWidth,CharHeight);

	HBITMAP hbmCharOld=(HBITMAP)SelectObject(hdcChar,hbmChar);


	unsigned char* buffer;

	int filesize=((CellWidth/8)*CharHeight+4)*96+4;

	buffer=new unsigned char[filesize];

	int fileindex=0;

	//font header
	buffer[fileindex++]=0x01;
	buffer[fileindex++]=0x60;
	buffer[fileindex++]=CharWidth;
	buffer[fileindex++]=CharHeight;

	int cellx;
	int celly;
	int pelx;
	int bytex;
	int pely;
	unsigned char pel;

	for(celly=0;celly<6;celly++)
	{
		for(cellx=0;cellx<16;cellx++)
		{
			//clear out cell
			for(pely=0;pely<CharHeight;pely++)
			{
				for(pelx=0;pelx<CellWidth;pelx++)
				{
					SetPixelV(hdcChar,pelx,pely,RGB(255,255,255));
				}
			}
			//copy cell
			BitBlt(hdcChar,0,0,CharWidth,CharHeight,hdc,cellx*CharWidth,celly*CharHeight,SRCCOPY);

			buffer[fileindex++]=0x00;
			buffer[fileindex++]=0x00;
			buffer[fileindex++]=CharWidth;
			buffer[fileindex++]=CharHeight;

			for(pely=0;pely<CharHeight;pely++)
			{
				for(bytex=0;bytex<(CellWidth/8);bytex++)
				{
					pel=0;
					for(pelx=0;pelx<8;pelx++)
					{
						if(GetPixel(hdcChar,bytex*8+pelx,pely)==RGB(0,0,0))
						{
							pel|=(1<<(7-pelx));
							cout<<"1";
						}
						else
						{
							cout<<"0";
						}
					}
					buffer[fileindex++]=pel;
				}
				cout<<endl;
			}
		}
	}

	HANDLE hfile=CreateFile(argv[2],GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);

	DWORD numwritten;

	WriteFile(hfile,buffer,filesize,&numwritten,NULL);

	CloseHandle(hfile);

	delete [] buffer;
	
	SelectObject(hdcChar,hbmCharOld);

	DeleteObject(hbmChar);

	DeleteDC(hdcChar);

	SelectObject(hdc,hbmOld);

	DeleteObject(hbmNew);

	DeleteDC(hdc);

	return(0);
}

